package  app01a;

import java.io.IOException;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import app01a.to.ProductTO;


public class ControllerServlet extends HttpServlet {
  public void doGet(HttpServletRequest request, HttpServletResponse response)
    throws IOException, ServletException {
    process(request, response);
  }

  public void doPost(HttpServletRequest request, HttpServletResponse response)
    throws IOException, ServletException {
    process(request, response);
  }

  private void process(HttpServletRequest request, HttpServletResponse response)
    throws IOException, ServletException {

    String action = request.getParameter("action");

    // execute an action 
    if (action.equals("displayAddProductForm")) {
      // there is nothing to be done
    }
    else if (action.equals("saveProduct")) {
      // read and save the product into the database
      ProductTO product = new ProductTO();
      product.setProductName(request.getParameter("productName"));
      product.setDescription(request.getParameter("description"));
      product.setPrice(request.getParameter("price"));

      // code for persisting the ProductTO object goes here

      request.setAttribute("product", product);
    }

    // forward to a view
    String dispatchUrl = null;
    if (action.equals("displayAddProductForm")) {
      dispatchUrl = "/jsp/displayAddProductForm.jsp";
    }
    else if (action.equals("saveProduct")) {
      dispatchUrl = "/jsp/displaySavedProduct.jsp";
    }
    if (dispatchUrl != null) {
      RequestDispatcher rd = request.getRequestDispatcher(dispatchUrl);
      rd.forward(request, response);
    }
  }
}
